﻿//
// Background
//
Titanium.UI.setBackgroundColor('#ffffff');
var menuWin = Titanium.UI.createWindow({
	title:L("app_name"),
	backgroundColor: "#ffffff",
	fullscreen:false,
	exitOnClose:true,
	url:"extra.js",
	top:0,
	orientationModes: [ Titanium.UI.PORTRAIT ] 
});

//
// Platform
//
var isAndroid = false;
var screenWidth = 320;
var screenHeight = 480;
var barHeight = 0;
var toolbarHeight = 33;
if (Titanium.Platform != undefined) { // emulator
	var device = Titanium.Platform.displayCaps;	
	if (device != undefined) {
		screenWidth = device.platformWidth;
		screenHeight = device.platformHeight;
	}
	
	if (Titanium.Platform.name == 'android') isAndroid = true;
	else {
		isAndroid = false;
		barHeight = 40;	
		
	}
}

Titanium.App.idleTimerDisabled = true;


/***** Update for big screen smart devices *****/

if ( isAndroid && screenWidth > screenHeight ) {
	var orientationTemp = screenWidth;
	screenWidth = screenHeight;
	screenHeight = orientationTemp;
}

// Android tablet has statusbar and title bar, e.g. the display size for Honeycomb system is 800/1232, instead of 800/1280 
//if ( isAndroid && Titanium.Platform.version >= 11 ) {
if ( isAndroid ) {
	var androidVersion = parseFloat( Titanium.Platform.version );
	if ( !isNaN(androidVersion) &&  androidVersion >= 3.0 && screenHeight > 1000 ) {
		screenHeight = screenHeight - 48;
	}
}

/***** End of Update for big screen smart devices *****/

screenHeight = screenHeight - barHeight; // toolbar
screenHeight = screenHeight - 50; 


//
// Constants
//
var vEdge = 20;
var hEdge = 20;
var spacer = 20;
var lineHeight = Math.floor((screenHeight - vEdge * 2) / 3);
var imgSize = lineHeight - spacer * 2;
var temp = Math.floor((screenWidth - hEdge * 2 - spacer * 2) / 3);
if (imgSize > temp) imgSize = temp;
var btnHeight = lineHeight - spacer * 2;
if (btnHeight > 80) btnHeight = 80;
var btnWidth = Math.floor((screenWidth - hEdge * 2 - spacer * 4) / 2);
var circleSize = Math.floor(btnWidth * 1.5);

var color1 = '#FF6414'; 
var color2 = '#FFE0FE'; 
var color3 = '#A3CD39';
var fontColor1 = '#4A4A4A';
var fontColor2 = '#ffffff';


var img1 = 'img1.png';
var img2 = 'img2.png';
var img3 = 'img3.png';
var img4 = 'img4.png';
var img5 = 'img5.png';
var img6 = 'img6.png';
var dot1 = 'dot1.gif';
var dot2 = 'dot2.gif';
var dot3 = 'dot3.gif';

var selectedDot = Titanium.App.Properties.getString("arc_dot");
if (selectedDot == null || selectedDot == '') selectedDot = dot1;

var level = Titanium.App.Properties.getString("arc_mode");
if (level == null || level == '') {
	Titanium.App.Properties.setString("arc_mode","flash");
	level = 'flash';
}


//
// Parameters
//

//
// Buttons
//
var imgBtn1;
var imgBtn2;
var imgBtn3;
var win01 = null;

var btn01 = Titanium.UI.createButton({
	top: vEdge + lineHeight + spacer,
	left: hEdge + spacer,
	width: btnWidth,
	height: btnHeight,
	title: L('menu1'),
	backgroundColor: (level == 'flash') ? color1 : color2,
	color: (level == 'flash') ? fontColor1 : fontColor2,
	borderRadius: 15,
	font: {
        fontSize: 20,
        fontWeight: 'bold'
    }
});

var btn02 = Titanium.UI.createButton({
	top: vEdge + lineHeight + spacer,
	left: Math.floor((screenWidth  + spacer) / 2),
	width: btnWidth,
	height: btnHeight,
	title: L('menu2'),
	backgroundColor: (level == 'computation') ? color1 : color2,
	color: (level == 'computation') ? fontColor1 : fontColor2,
	borderRadius: 15,
	font: {
        fontSize: 20,
        fontWeight: 'bold'
    }
});

var circle = Titanium.UI.createButton({
	top: vEdge + lineHeight * 2,
	left: Math.floor((screenWidth - circleSize)/2),
	width: circleSize,
	height: Math.floor(circleSize / 2),
	title: L('start'),
	backgroundColor: color3,
	color: fontColor1,
	borderRadius: Math.floor(circleSize/2),
    borderWidth: 1,
    borderColor: color3,
	font: {
        fontSize: 26,
        fontWeight: 'bold'
    }
});

btn01.addEventListener('click',function(e)
{
	Titanium.App.Properties.setString("arc_mode","flash");
	btn01.backgroundColor = color1;
	btn02.backgroundColor = color2;
	btn01.color = fontColor1;
	btn02.color = fontColor2;
	
});

btn02.addEventListener('click',function(e)
{
	Titanium.App.Properties.setString("arc_mode","computation");
	btn01.backgroundColor = color2;
	btn02.backgroundColor = color1;
	btn01.color = fontColor2;
	btn02.color = fontColor1;
});

circle.addEventListener('click',function(e)
{
	Titanium.App.Properties.setString("arc_winOpened","yes");
	
	win01 = null;
	if (win01 == null) {
		win01 = Titanium.UI.createWindow({
			url:"card.js",
			title: L("app_name")
		});
	}
	if (isAndroid) win01.open();
	else win01.open({modal:true, fullscreen:false});
});

if (isAndroid) {
	imgBtn1 = Titanium.UI.createButton({
		backgroundImage: img1,
		top: vEdge + spacer,
		left: hEdge,
		width: imgSize,
		height: imgSize,
		title: '',
		borderRadius : Math.floor(imgSize / 2),
		borderWidth : 1,
		borderColor: (selectedDot == dot1) ? color1 : color2
	});
	imgBtn2 = Titanium.UI.createButton({
		backgroundImage: img2,
		top: vEdge + spacer,
		left: Math.floor((screenWidth - imgSize) / 2),
		width: imgSize,
		height: imgSize,	
		title: '',
		borderRadius : Math.floor(imgSize / 2),
		borderWidth : 1,
		borderColor: (selectedDot == dot2) ? color1 : color2
	});
	imgBtn3 = Titanium.UI.createButton({
		backgroundImage: img3,
		top: vEdge + spacer,
		left: screenWidth - hEdge - imgSize,
		width: imgSize,
		height: imgSize,
		title: '',
		borderRadius : Math.floor(imgSize / 2),
		borderWidth : 1,
		borderColor: (selectedDot == dot3) ? color1 : color2
	});

	imgBtn1.addEventListener('click',function(e)
	{
		Titanium.App.Properties.setString("arc_dot", dot1);
		imgBtn1.borderColor = color1;	
		imgBtn2.borderColor = color2;	
		imgBtn3.borderColor = color2;
	});
	imgBtn2.addEventListener('click',function(e)
	{
		Titanium.App.Properties.setString("arc_dot", dot2);
		imgBtn1.borderColor = color2;
		imgBtn2.borderColor = color1;
		imgBtn3.borderColor = color2;
	});
	imgBtn3.addEventListener('click',function(e)
	{
		Titanium.App.Properties.setString("arc_dot", dot3);
		imgBtn1.borderColor = color2;
		imgBtn2.borderColor = color2;
		imgBtn3.borderColor = color1;
	});
}
else
{
	imgBtn1 = Titanium.UI.createButton({
		style: Titanium.UI.iPhone.SystemButtonStyle.PLAIN,
		image: img4,
		top: vEdge + spacer,
		left: hEdge,
		width: imgSize,
		height: imgSize,
		title: '',
		borderRadius : Math.floor(imgSize / 2),
		backgroundColor: (selectedDot == dot1) ? color1 : color2
	});
	
	
	imgBtn2 = Titanium.UI.createButton({
		style: Titanium.UI.iPhone.SystemButtonStyle.PLAIN,
		image: img5,
		top: vEdge + spacer,
		left: Math.floor((screenWidth - imgSize) / 2),
		width: imgSize,
		height: imgSize,	
		title: '',
		borderRadius : Math.floor(imgSize / 2),
		backgroundColor:  (selectedDot == dot2) ? color1 : color2
	});
	imgBtn3 = Titanium.UI.createButton({
		style: Titanium.UI.iPhone.SystemButtonStyle.PLAIN,
		image: img6,
		top: vEdge + spacer,
		left: screenWidth - hEdge - imgSize,
		width: imgSize,
		height: imgSize,
		title: '',
		borderRadius : Math.floor(imgSize / 2),
		backgroundColor: (selectedDot == dot3) ? color1 : color2
	});

	btn01.style = Titanium.UI.iPhone.SystemButtonStyle.PLAIN;
	btn02.style = Titanium.UI.iPhone.SystemButtonStyle.PLAIN;
	circle.style = Titanium.UI.iPhone.SystemButtonStyle.PLAIN;
	
	imgBtn1.addEventListener('click',function(e)
	{
		Titanium.App.Properties.setString("arc_dot", dot1);
		imgBtn1.backgroundColor = color1;
		imgBtn2.backgroundColor = color2;
		imgBtn3.backgroundColor = color2;
		
	});
	imgBtn2.addEventListener('click',function(e)
	{
		Titanium.App.Properties.setString("arc_dot", dot2);
		imgBtn1.backgroundColor = color2;
		imgBtn2.backgroundColor = color1;
		imgBtn3.backgroundColor = color2;
	});
	imgBtn3.addEventListener('click',function(e)
	{
		Titanium.App.Properties.setString("arc_dot", dot3);
		imgBtn1.backgroundColor = color2;
		imgBtn2.backgroundColor = color2;
		imgBtn3.backgroundColor = color1;
	});
}

menuWin.add(imgBtn1);
menuWin.add(imgBtn2);
menuWin.add(imgBtn3);
menuWin.add(btn01);
menuWin.add(btn02);
menuWin.add(circle);


Titanium.App.Properties.setString("arc_preferenceOpened", "no");
Titanium.App.Properties.setString("arc_winOpened","no");

menuWin.open();


menuWin.addEventListener('android:back', function (e) {
	if (Titanium.App.Properties.getString("arc_preferenceOpened") == "yes") {
		Titanium.App.Properties.setString("arc_preferenceOpened", "no");
		if (Titanium.App.Properties.getString("arc_winOpened") == "yes") {
			win01.show();			
		}
		else {
			menuWin.show(); 	
		}
	}
	else {
		if (Titanium.App.Properties.getString("arc_winOpened") == "yes") {			
			win01.close();
			win01 = null;	
			Titanium.App.Properties.setString("arc_winOpened", "no");
		}
		else {
			menuWin.close();
		}
	}

});
