﻿//
// Background
//
Titanium.UI.setBackgroundColor('#ffffff');

//
// Platform
//
var isAndroid = false;
var screenWidth = 320;
var screenHeight = 480;
var barHeight = 0;
var toolbarHeight = 33;
if (Titanium.Platform != undefined) { // emulator
	var device = Titanium.Platform.displayCaps;	
	if (device != undefined) {
		screenWidth = device.platformWidth;
		screenHeight = device.platformHeight;
	}
	
	if (Titanium.Platform.name == 'android') isAndroid = true;
	else {
		isAndroid = false;
		barHeight = 0; //fullscreen = false, barHeight = 0
		screenHeight = screenHeight - 30;
	}
}

/***** Update for big screen smart devices *****/

if ( isAndroid && screenWidth > screenHeight ) {
	var orientationTemp = screenWidth;
	screenWidth = screenHeight;
	screenHeight = orientationTemp;
}

// Android tablet has statusbar and title bar, e.g. the display size for Honeycomb system is 800/1232, instead of 800/1280 
//if ( isAndroid && Titanium.Platform.version >= 11 ) {
if ( isAndroid ) {
	var androidVersion = parseFloat( Titanium.Platform.version );
	if ( !isNaN(androidVersion) &&  androidVersion >= 3.0 && screenHeight > 1000 ) {
		screenHeight = screenHeight - 48;
	}
}

/***** End of Update for big screen smart devices *****/

screenHeight = screenHeight - barHeight;

var activity;
var win = Titanium.UI.currentWindow;
if (!isAndroid) win.title = L("menu1");

if (isAndroid) {
	activity = Titanium.Android.currentActivity;
	
}
var frontLabel1 = L('menu1');
var frontLabel2 = L('menu2');
	
//
// Constants
//

var lang = "e";
if (!isAndroid) {
	frontLabel1 = L("en");
	frontLabel2 = L("en");
}

var btnColor = "#FA9CB8";
var btnDisabledColor = "#DED2BF";
var fontColor = "#000000";
var disabledFontColor = "#AAAAAA";
var intervalFloats = new Array(0.4, 1.2, 2.4);
var intervalInts = new Array(400, 1200, 2400);
var dotImg = Titanium.App.Properties.getString("arc_dot");
if (dotImg == null || dotImg == '') dotImg = 'dot1.gif';
var audioDir = "audio/";
var audioFileExt = ".wav"; 
var itemIds = new Array('401', '402', '403', '404', '405', '406', '407', '408', '409', '410');
var labels = new Array('1', '2', '3', '4', '5', '6', '7', '8', '9', '10');

var imagesGroup = new Array();
var shuffledGroup = new Array();
var flash = true;
var computation = false;
var pauseTime = 0;

if (!Titanium.App.Properties.hasProperty("interval")) {
	Titanium.App.Properties.setString("interval", intervalFloats[1] + "");
}

//
// Parameters
//
var slidesCount = 10;

var btnSizeName = 48;
var btnSize = 48;
if (screenHeight > 600) 
{
	btnSizeName = 64;
	btnSize = 64;
}
var btnWidth = btnSize;
var btnHeight = btnSize;
var cardWidth = screenWidth - 10; 
var cardHeight = screenHeight - btnHeight - 60;

var btnsSpace = 20;
var btnsLeft = Math.floor((screenWidth - btnWidth*3 - 40) / 2);
var startIndex = 0;
var currentIndex = Math.floor(Math.random() * 10);
var preIndex = 0;
var stop = false;
var started = false;
var interval = intervalInts[1];
getInterval();
var descColor = 'orange';

var mode = Titanium.App.Properties.getString("arc_mode"); 
if (mode == "computation")
{
	computation = true;	
	flash = false;
	descColor = 'purple';
	pauseTime = 500;
	if (!isAndroid) win.title = L("menu2");
}

var playerIndex = -1;
var players = [];


/************************
// Calculation equations
// 4x + 2y1 + 5z = cardHeight;
// 3x + 2y2 + 4z = cardWidth;
// x~ dots distance, y1,y2 ~ edge, z ~ dot's width
**************************/
var x = 20;
if ( isAndroid && screenHeight > 1000 ) x = Math.floor((cardWidth - 200) / 11);
var temp1 = Math.floor(cardHeight / 14);
var temp2 = Math.floor(cardWidth / 11);
if (x > temp1) x = temp1;
if (x > temp2) x = temp2;
var z = 2 * x;
y1 = Math.floor((cardHeight - 14 * x) / 2);
y2 = Math.floor((cardWidth - 11 * x) / 2);
var row1Y = y1;
var row2Y = y1 + z + x;
var row3Y = y1 + 2 * z + 2 * x;
var row4Y = y1 + 3 * z + 3 * x;
var row5Y = y1 + 4 * z + 4 * x;
var col1X = y2;
var col2X = y2 + z + x;
var col3X = y2 + 2 * z + 2 * x;
var col4X = y2 + 3 * z + 3 * x;

//
// Label View - Slideshow's interval information
//
var intervalLabel = Titanium.UI.createLabel({
	text:'6',
	height:'auto',
    width:'auto',
	color:'#000',
	font:{fontSize:10},
	top: barHeight + 1 + 30,
	left: 1
});

//
// Image View - Card Image
//
var cardHolder = Titanium.UI.createView({
	width: screenWidth,
	height: screenHeight,
	top: barHeight + 2,
	left:5,
	backgroundColor: "#ffffff"
});


var card = Titanium.UI.createView({
	width: cardWidth,
	height: cardHeight,
	backgroundColor: "#ffffff",
	top: 0, 
	left:0
});


var cardDesc = Titanium.UI.createLabel({
	text: flash ? frontLabel1 : frontLabel2,
	color:descColor,
	width: 200,
	font:{fontSize:30},
	textAlign: 'center'
});


var top = 10;
var left = 10;
var halfPoint = Math.floor(slidesCount / 2);

for(var i = 0; i< slidesCount; i++) {
	switch(i)
	{
		case 0:
			top = row2Y;
			left = col2X;
			break;
		case 1:
			top = row3Y;
			left = col3X;
			break;
		case 2:
			top = row2Y;
			left = col4X;
			break;
		case 3:
			top = row1Y;
			left = col3X;
			break;
		case 4:
			top = row1Y;
			left = col1X;
			break;	
		case 5:
			top = row5Y;
			left = col3X;
			break;
		case 6:
			top = row5Y;
			left = col1X;
			break;
		case 7:
			top = row4Y;
			left = col2X;
			break;
		case 8:
			top = row4Y;
			left = col4X;
			break;
		case 9:
			top = row3Y;
			left = col1X;
			break;	
	}
	
	imagesGroup[i] = Titanium.UI.createImageView({
		top: top,
		left: left,
		width: z,
		height: z,
		url: dotImg
	});
	shuffledGroup[i] = Titanium.UI.createImageView({
		top: top,
		left: left,
		width: z,
		height: z,
		url: dotImg
	});
}

cardHolder.add(card);
getInterval();


//
// Buttons
//
var	btn2 = Titanium.UI.createButton({
	image:"ctrl_icons/play" + btnSizeName +  ".png",
	top:barHeight + cardHeight + 5,
	left:btnsLeft + btnWidth + 20,
	width: btnWidth,
	height: btnHeight,
	visible:false,
	title: '',
	backgroundColor: 'white'

});

var	btn4 = Titanium.UI.createButton({
	image: "ctrl_icons/stop" + btnSizeName +  ".png",
	top:barHeight + cardHeight + 5,
	left:btnsLeft + btnWidth + 20,
	width: btnWidth,
	height: btnHeight,	
	title: '',
	backgroundColor: 'white'
});

btn2.addEventListener('click',function(e)
{

	card.remove(cardDesc);
	
	stop = false;
	started = false;
	btn2.hide();
	btn4.show();
	setCurrentIndex(Math.floor(Math.random() * 10));	
	getInterval();
	slideShow();	
	
	var speedStr = '';
	switch(interval) {
		case intervalInts[0]:
			speedStr = L("fast");
			break;
		case intervalInts[1]:
			speedStr = L("normal");
			break;
		case intervalInts[2]:
			speedStr = L("slow");
			break;
		default:
			speedStr = L("normal");
			break;
	}
});
btn4.addEventListener('click',function(e)
{	
	stop = true;
	started = false;
	btn4.hide();
	btn2.show();	
	setTimeout(function(){showDesc();card.add(cardDesc);}, interval);

});


cardHolder.add(btn2);
cardHolder.add(btn4);
win.add(cardHolder);

Titanium.App.addEventListener('android_menu_pref_click', function() {	
	btn4.hide();
	btn2.show();	
	setTimeout(function(){showDesc();card.add(cardDesc);}, interval);
	stop = true;
	started = false;
	
});


//
// Menu - iPhone
// Menu - Android (extra.js)
//

var row1 = Titanium.UI.createTableViewRow({
	title: L("interval"),
	backgroundColor: '#ffffff',
	color: '#000000',
	hasDetail: true			
});
var row2 = Titanium.UI.createTableViewRow();
var row2Label = Titanium.UI.createLabel({
	color:'#000000',
	font:{fontSize:10},
	left:10,
	text:L("version") + ": " + L("version_name")
});
row2.add(row2Label);
	
var row3 = Titanium.UI.createTableViewRow({
	title: L("more_apps"),
	backgroundColor: '#ffffff',
	color: '#000000',
	hasDetail: true			
});		
var intervalDialog = null;
row1.addEventListener('click', function() {			
	if (intervalDialog == null) {
		intervalDialog = Titanium.UI.createOptionDialog({
			options:[L("fast"), 
				L("normal"), 
				L("slow"),
				L("cancel")],
				title:L("interval"),
				cancel: 4
		});
	}	
	switch(interval) {
		case intervalInts[0]:
			intervalDialog.setDestructive(0);
			break;
		case intervalInts[1]:
			intervalDialog.setDestructive(1);
			break;
		case intervalInts[2]:
			intervalDialog.setDestructive(2);
			break;
	}	
		
	// add event listener
	intervalDialog.addEventListener('click',function(e)
	{
		switch(e.index){
			case 0:
				interval = intervalInts[0];
				Titanium.App.Properties.setString("interval", intervalFloats[0] + "");
				break;
			case 1:
				interval = intervalInts[1];
				Titanium.App.Properties.setString("interval", intervalFloats[1] + "");
				break;
			case 2:
				interval = intervalInts[2];
				Titanium.App.Properties.setString("interval", intervalFloats[2] + "");
				break;
			default:
				break;
		}
	});
			
	intervalDialog.show();
});	

row3.addEventListener('click', function() {
	Titanium.Platform.openURL('http://itunes.com/apps/arcadiainc');
});			

var prefData = [];			
prefData[0] = Titanium.UI.createTableViewSection({headerTitle:L("preference_config")});
prefData[0].add(row1);
prefData[1] = Titanium.UI.createTableViewSection({headerTitle:L("preference_info")});
prefData[1].add(row2);	
prefData[1].add(row3);
 
var tv = Titanium.UI.createTableView({
	style: Titanium.UI.iPhone.TableViewStyle.GROUPED,
	data:prefData
});		
			
if (!isAndroid) {
	//
	// TOOLBAR BUTTONS
	//	
	// button to show information
	var configWin = null;
	var flexSpace = Titanium.UI.createButton({
		systemButton:Titanium.UI.iPhone.SystemButton.FLEXIBLE_SPACE
	});
	var back = Titanium.UI.createButton({
		systemButton:Titanium.UI.iPhone.SystemButton.DONE
	});
	var info = Titanium.UI.createButton({	
		systemButton:Titanium.UI.iPhone.SystemButton.INFO_DARK
	});	
	Titanium.UI.currentWindow.leftNavButton = back;
	Titanium.UI.currentWindow.rightNavButton = info;
	Titanium.UI.currentWindow.navBarHidden = false;
	
	back.addEventListener('click', function()
	{
		Titanium.UI.currentWindow.close();
	});			
	
	function iphoneFunc() {
		Titanium.UI.currentWindow.rightNavButton = null;
		var waitTime = interval;		
		if (stop) waitTime = 0;
		stop = true;
		started = false;
		btn4.hide();
		btn2.show();		
		setTimeout(function(){		
			showDesc();
			card.add(cardDesc);		
			Titanium.UI.currentWindow.remove(cardHolder);
			Titanium.UI.currentWindow.title = L("preference");	
			Titanium.UI.currentWindow.leftNavButton = closeme;	
			Titanium.UI.currentWindow.add(tv);	
		}, waitTime);
		
	}	
	info.addEventListener('click', iphoneFunc);
}

var closeme = Titanium.UI.createButton({		
	systemButton:Titanium.UI.iPhone.SystemButton.DONE
});	
		
closeme.addEventListener('click', function()
{	
	Titanium.UI.currentWindow.remove(tv);		
	if (mode == "computation") Titanium.UI.currentWindow.title = L("menu2");
	else Titanium.UI.currentWindow.title = L("menu1");
	Titanium.UI.currentWindow.rightNavButton = info;
	Titanium.UI.currentWindow.leftNavButton = back;
	Titanium.UI.currentWindow.add(cardHolder);			
});	

setTimeout(function(){slideShow();}, 500);

win.addEventListener('close', closeWin);


//
// Functions
//

function closeWin(e) {
	stop = true;
	started = false;
	btn4.hide();
	btn2.show();	
	intervalLabel.text = "";
	setTimeout(function(){showDesc();}, interval);	
}

function shuffle(sourceArray) {
    for (var n = 0; n < sourceArray.length - 1; n++) {
        var k = n + Math.floor(Math.random() * (sourceArray.length - n));

        var temp = sourceArray[k];
        sourceArray[k] = sourceArray[n];
        sourceArray[n] = temp;
    }
	return sourceArray;
}

function showImage(index) {	
	shuffledGroup = shuffle(shuffledGroup);
	
	for (var i = 0; i <= index; i++) {
		card.add(shuffledGroup[i]);
	}
	
	
}


function showDesc() {
	for (var i = 0; i < slidesCount; i++)
	{	
		if (i <= currentIndex)
			card.remove(shuffledGroup[i]);		
		else break;
	}
	

}

function playAudio(index) {
	
	var audioFile = audioDir + lang + itemIds[index] + audioFileExt;

	if (playerIndex > -1){
        players[playerIndex].release();
    }
    playerIndex++;
	
	players[playerIndex] = Titanium.Media.createSound({url:audioFile});
	if (!stop) {
		players[playerIndex].addEventListener('complete', function() {			
			slideShow();		
		});
		players[playerIndex].play();
	} else {
		players[playerIndex].play();
	}
}

function showImageComputation(index) {
	shuffledGroup = shuffle(shuffledGroup);
	var pauseIndex = Math.floor((index + 1) / 2);
	if (pauseIndex == 0) pauseIndex = 1;
	for (var i = 0; i < pauseIndex; i++)
	{
		card.add(shuffledGroup[i]);		
	}	
	
	setTimeout(function(){playAudioComputation(pauseIndex - 1, pauseIndex, index)}, interval - 400);
	

}

function addImageGroup2Computation(start, index) {
	for (var i = start; i <= index; i++) 
	{	
		card.add(shuffledGroup[i]);
	}
	setTimeout(function(){playAudioComputation(index, -1, index)}, interval - 400);
	
}

var from = 0;
function getFromValue() {
	return from;
}
function comp1() {
	players[playerIndex].removeEventListener('complete', comp1);
	showDesc();
	slideShow();
}
function comp2() {	
	players[playerIndex].removeEventListener('complete', comp2);
	addImageGroup2Computation(getFromValue(), currentIndex);
}


function playAudioComputation(index, start, end) {
	from = start;	
	var audioFile = audioDir + lang + itemIds[index] + audioFileExt;	
	
	if (playerIndex > -1){
        players[playerIndex].release();
    }
    playerIndex++;
	
	players[playerIndex] = Titanium.Media.createSound({url:audioFile});	
	players[playerIndex].play();
	
	if (!stop) {
		if (index == end) {
			players[playerIndex].addEventListener('complete', comp1);
		} else {
			players[playerIndex].addEventListener('complete', comp2);
		}		
	} else {
		showDesc();
	}
	
}

function slideShow() {
	showDesc();

	if (!stop)
	{		
		if (!started) {
			started = true;
		}
		else
		{
			var tmp = Math.floor(Math.random() * 10);
			setCurrentIndex(tmp);
		}
		
		if (flash) 
		{		
			showImage(currentIndex);
			
			if (interval > 400) {
				setTimeout(function(){playAudio(currentIndex)}, interval - 400);
			} else {
				playAudio(currentIndex);	
			}
		}
		else
		{
			showImageComputation(currentIndex);
		}
		
		return;
	}
}

function setCurrentIndex(newValue) {
	preIndex = currentIndex;
	currentIndex = newValue;
}


function getInterval() {
	var tmp = Titanium.App.Properties.getString("interval", intervalFloats[1] + "");
	interval = parseFloat(tmp) * 1000;
}

win.open({modal:true});
